(function () {
    const magnet = new RegExp('magnet:\\?xt=urn:btih:\\w{10,}([-a-zA-Z0-9()@:%_\\+.~#?&//=]*)', 'gim');
    const http = new RegExp('(https?:\\/\\/)(([0-9a-z.]+\\.[a-z]+)|(([0-9]{1,3}\\.){3}[0-9]{1,3}))(:[0-9]+)?(\\/[0-9a-z%/.\\-_]*)?(\\?[0-9a-z=&%_\\-]*)?(\\#[0-9a-z=&%_\\-]*)?', 'gim');
    const ftp = new RegExp('(ftp?:\\/\\/)(([0-9a-z.]+\\.[a-z]+)|(([0-9]{1,3}\\.){3}[0-9]{1,3}))(:[0-9]+)?(\\/[0-9a-z%/.\\-_]*)?(\\?[0-9a-z=&%_\\-]*)?(\\#[0-9a-z=&%_\\-]*)?', 'gim');
    const ed2k = new RegExp('(ed2k?:\\/\\/|file|)(.+|)\\/', 'gim');
    const thunder = new RegExp('(thunder?:\\/\\/)([a-zA-Z0-9]+=+)', 'gim');
    const xunlei = new RegExp('(http|https)://pan.xunlei.com/s/[0-9a-zA-Z-_]{8,30}([\\s\\S]{0,20}(访问码|提取码|密码|)[\\s\\S]{0,10}[0-9a-zA-Z]{4}|)', 'gim');

    var urls = [];
    var working = false;
    function work(force) {
        if (document.documentElement == null) {
            return;
        }

        if (working) {
            return
        }

        working = true;
        console.log('work:' + new Date().getMilliseconds() + ", force:" + force);
        XWebViewApi.call('notifySniffStart', '', 'sniffer', 'this');

        if (!force && urls.length > 0) {
            for (var i = 0; i < urls.length; ++i) {
                XWebViewApi.call('notifySniffUrl', urls[i], 'sniffer', 'this');
            }
            XWebViewApi.call('notifySniffEnd', '', 'sniffer', 'this');
            console.log('work end:' + new Date().getMilliseconds());
            working = false;
            return;
        }

        var m = document.documentElement.outerHTML.match(magnet);
        var h = document.documentElement.outerHTML.match(http);
        var f = document.documentElement.outerHTML.match(ftp);
        var e = document.documentElement.outerHTML.match(ed2k);
        var t = document.documentElement.outerHTML.match(thunder);
        var x = document.documentElement.outerHTML.match(xunlei);

        if (m != null) {
            for (var i = 0; i < m.length; ++i) {
                XWebViewApi.call('notifySniffUrl', m[i], 'sniffer', 'this');
                urls[urls.length] = m[i];
            }
        }

        if (h != null) {
            for (var i = 0; i < h.length; ++i) {
                XWebViewApi.call('notifySniffUrl', h[i], 'sniffer', 'this');
                urls[urls.length] = h[i];
            }
        }

        if (f != null) {
            for (var i = 0; i < f.length; ++i) {
                XWebViewApi.call('notifySniffUrl', f[i], 'sniffer', 'this');
                urls[urls.length] = f[i];
            }
        }

        if (e != null) {
            for (var i = 0; i < e.length; ++i) {
                XWebViewApi.call('notifySniffUrl', e[i], 'sniffer', 'this');
                urls[urls.length] = e[i];
            }
        }

        if (t != null) {
            for (var i = 0; i < t.length; ++i) {
                XWebViewApi.call('notifySniffUrl', t[i], 'sniffer', 'this');
                urls[urls.length] = t[i];
            }
        }

        if (x != null) {
            for (var i = 0; i < x.length; ++i) {
                var u = x[i].replace(/\s*(访问码|提取码|密码)[\s\S]{0,10}([0-9a-zA-Z]{4})/gi, '?pwd=$2')
                XWebViewApi.call('notifySniffUrl', u, 'browser', 'this');
                urls[urls.length] = u;
            }
        }

        XWebViewApi.call('notifySniffEnd', '', 'sniffer', 'this');
        console.log('work end:' + new Date().getMilliseconds());
        working = false;
    }

    XWebViewApi.registerCommand('sniffPageURL', work);
    /*function watchBodyChange(onchange) {
        let timeout;
        let observer = new MutationObserver(() => {
            if (!timeout) {
                timeout = setTimeout(() => {
                    timeout = null;
                    onchange();
                }, 200);
            }
        });
        observer.observe(document.documentElement, {
            childList: true,
            subtree: true,
            attributes: true,
            characterData: true
        });
    }

    function whenDOMReady(f) {
        if (document.body) f();
        else window.addEventListener("DOMContentLoaded", f);
    }

    whenDOMReady(() => {
        watchBodyChange(work);
    });*/
})();