var LINK_ELEMENT_ID = "x_link_element_id";
var STYLE_ELEMENT_ID = "x_style_element_id";
var LINK_EXTRA_CSS_ID = "x_link_extra_css_id";
var STYLE_EXTRA_CSS_ID = "x_style_extra_css_id";
//var CURRENT_VIDEO;
var CURRENT_ELEMENT;
var LAST_HIT_ELEMENT;
var SELECTED_ELEMENT;
var g_element_rules = null;
var g_max_ad_container_height = 320;
var g_min_ad_container_height = 20;
var g_hit_rules = [];
var g_auto_fill_keywords = ["pass", "name", "usr", "user", "addr", "mail", "nick", "phone", "account", "phone", "用户", "手机", "邮箱", "地址", "账号", "昵称", "密码"];
var g_fill_form_data = {};
var last_point = {
	left : 0,
	top : 0
};
var last_touch;
var video_gesture_mode = false;
var seek_to = -1;
var has_submit;
var g_dom_load_finished = false;
var g_page_load_finished = false;
var g_rule_try_times = 5;
var in_selection = false;
var g_timer;
var last_touch_a_element = null;
var call_timeout;
var try_sniff_times = 0;
var TKK = function() {
	var e = 561666268,
	t = 1526272306;
	return "406398." + (e + t)
}();

function gen_uuid(len, radix) {
    var chars = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'.split('');
    var uuid = [], i;

    radix = radix || chars.length;
    if (len) { // Compact form
        for (i = 0; i < len; i++) {
            uuid[i] = chars[0 | Math.random() * radix];
        }
    } else {
        // rfc4122, version 4 form
        var r;

        // rfc4122 requires these characters
        uuid[8] = uuid[13] = uuid[18] = uuid[23] = '-';
        uuid[14] = '4';

        // Fill in random data.  At i==19 set the high bits of clock sequence as
        // per rfc4122, sec. 4.1.5
        for (i = 0; i < 36; i++) {
            if (!uuid[i]) {
                r = 0 | Math.random()*16;
                uuid[i] = chars[(i == 19) ? (r & 0x3) | 0x8 : r];
            }
        }
    }

    return uuid.join('');
}

mbrowser = xBrowser = {
    adMarkMode: false,
    adBlock: true,
    adBlockLevel: 0,
    whiteHosts: ',baidu.com,xunlei.com,taobao.com,jd.com,ebay.com,gs.vasthunt.com,tmall.com,youku.com,iqiyi.com,qq.com,bilibili.com,le.com,mgtv.com,gamezop.com,',
    videos: {},
    log: function(msg) {
        //console.log(msg);
        //XLBrowser.sendMessage('log', msg, '');
    },
    uuid: function() {
        return gen_uuid(32, 16);
    },
    time: function(msg) {
        //console.time(msg);
    },
    timeEnd: function(msg) {
        //console.timeEnd(msg);
    },
    isInWhiteHosts: function(host) {
        var hosts = xBrowser.whiteHosts;
        if (host != null) {
            if (hosts.indexOf(',' +  host + ',') >= 0) {
                return true;
            }

            var rootDomain = host;
            var idx = -1, idx2 = -1;

            do {
                idx = rootDomain.indexOf('.');
                idx2 = rootDomain.lastIndexOf('.');

                if (idx2 > idx) {
                    rootDomain = rootDomain.substring(idx + 1);
                    if (hosts.indexOf(',' +  rootDomain + ',') >= 0) {
                        return true;
                    }
                }
            } while(idx2 > idx);
        }

        return false;
    },
    getVideoPlaySrc: function(e) {
        if (!e) {
            return "";
        }

        var src = e.src;
        if (!src || "" == src) {
            var c = e.querySelector("source");
            if (c) {
                src = c.src;
            }
        }

        if (src && src != "") {
            return src;
        }

        return "";
    },
    getVideoById: function(id) {
        var videoEles = Object.keys(xBrowser.videos);
        for (var i = 0; i < videoEles.length; ++i) {
            var videoEle = videoEles[i];
            var video = xBrowser.videos[videoEles];

            if (video && id == video.id) {
                if (video.target != null) {
                    return video.target;
                }

                return videoEle;
            }
        }

        return null;
    },
    getVideo: function(e) {
        var videoEle = (e instanceof HTMLVideoElement) ? e : (e.target ? e.target : e);

        if (!xBrowser.videos[videoEle]) {
            xBrowser.videos[videoEle] = {id:xBrowser.uuid(), target:null, url:"", title:"", page:"", duration:0.0, progress:0.0, width:0, height:0};
        }

        var video = xBrowser.videos[videoEle];
        video.target = videoEle;

        if (!video.url || video.url == "") {
            video.url = xBrowser.getVideoPlaySrc(videoEle);
        }

        if (isNaN(video.duration) || video.duration <= 0 || video.duration <= 0.0) {
            video.duration = videoEle.duration;
        }

        if (isNaN(video.width) || video.width <= 0) {
            video.width = videoEle.videoWidth;
        }

        if (isNaN(video.height) || video.height <= 0) {
            video.width = videoEle.videoHeight;
        }

        if (!video.title || video.title == "") {
            video.title = document.title;
        }

        if (!video.page || video.page == "") {
            video.page = location.href;
        }

        return video;
    },
    notifyVideoPaused: function(e) {
        xBrowser.log("sniff-video >>> notifyVideoPaused e:" + e);
        var video = xBrowser.getVideo(e);
        XLBrowser.sendMessage('onVideoPaused', JSON.stringify(video), '');
    },
    notifyVideoTimeUpdate: function(e) {
        xBrowser.log("sniff-video >>> notifyVideoTimeUpdate e: " + e + ", currentTime:" + e.target.currentTime + ", duration:" + e.target.duration);
        var video = xBrowser.getVideo(e);
        video.progress = e.target.currentTime;
        XLBrowser.sendMessage('onVideoProgress', JSON.stringify(video), '');
    },
    notifyVideoLoad: function(e) {
        xBrowser.log("sniff-video >>> notifyVideoLoad e:" + e);
        var video = xBrowser.getVideo(e);
        XLBrowser.sendMessage('onVideoLoaded', JSON.stringify(video), '');
    },
    notifyVideoPlayed: function(e) {
        //src, duration, currentTime, volume, currentSrc
        //e.target.src, e.target.duration, e.target.currentTime, e.target.volume, e.target.currentSrc
        xBrowser.log("sniff-video >>> notifyVideoPlayed e:" + e);
        var video = xBrowser.getVideo(e);
        XLBrowser.sendMessage('onVideoPlayed', JSON.stringify(video), '');
    },
    notifyHasVideoTag: function(src, e) {
        xBrowser.log("sniff-video >>> notifyHasVideoTag e:" + e + ", src:" + src);
        var video = xBrowser.getVideo(e);
        XLBrowser.sendMessage('onVideoAdded', JSON.stringify(video), '');
    },
    notifySniffMediaRes: function(b) {
        xBrowser.log("sniff-video >>> notifySniffMediaRes b:" + b);
    },
    addTagToResource: function(href, tag) {
        xBrowser.log("sniff-video >>> addTagToResource href:" + href + ", tag:" + tag);
    },
    sendLongPress: function(x, y) {
        XLBrowser.sendMessage('sendLongPress', '{"x":' + x + ', "y":' + y + '}', '')
    },
    onElementHitTest: function(e) {
        xBrowser.log("onElementHitTest: " + JSON.stringify(e));
    },
    onTouchEventElement: function() {
        xBrowser.log(">>> i click button");
    },
    setHitElementMarkable: function() {
        xBrowser.log(">>> setHitElementMarkable");
    },
    isInMarkAdMode: function() {
        return xBrowser.adMarkMode
    },
    onDOMContentLoaded: function() {

    },
    adBlockActived: function() {
        return xBrowser.adBlock;
    },
    addAdBlockRule: function(rule, host, url, type) {
        var params = {}
        params.rule = rule;
        params.host = host;
        params.url = url;
        params.type = type;
        XLBrowser.sendMessage('addAdBlockRule', JSON.stringify(params), '')
    },
    previewAdBlockRule: function(rule, host, url, type) {
        var params = {}
        params.rule = rule;
        params.host = host;
        params.url = url;
        params.type = type;
        XLBrowser.sendMessage('previewAdBlockRule', JSON.stringify(params), '')
    },
    onSelectTextChange: function(e, t) {
        xBrowser.log("onSelectTextChange e:" + e + ", t:" + t);
    },
    getElementRules: function(host) {
        if (g_element_rules) {
            return g_element_rules;
        }

        return []
    },
    logBlockOneAd: function(href, host, rule, type) {
        xBrowser.log("logBlockOneAd href:" + href + ", host:" + host + ", rule:" + rule + ", type:" + type);
    },
    getVersionCode: function() {
        return 500;
    },
    getToken: function() {
        return "";
    },
    fetchScript: function(id) {

    }
}

function remove_script(e) {
	for (var t = e.querySelectorAll("script"), n = 0; n < t.length; n++) {
		var o = t[n];
		o.parentNode && o.parentNode.removeChild(o)
	}
}
function remove_style(e) {
	for (var t = e.querySelectorAll("style"), n = 0; n < t.length; n++) {
		var o = t[n];
		o.parentNode && o.parentNode.removeChild(o)
	}
}
function view_source() {
	var e = document.documentElement.outerHTML;
	xBrowser.viewSource(e)
}
function save_source() {
	var e = document.documentElement;
	remove_script(e);
	var t = e.outerHTML;
	xBrowser.saveSource(t)
}
function save_text() {
	var e = extract_content_node();
	if (null != e) {
		var t = e.innerText;
		xBrowser.saveText(t)
	} else {
		var n = document.documentElement,
		t = n.innerText;
		xBrowser.saveText(t)
	}
}

//function notifyHitTest(e, t) {
//	var n = {};
//	n.tagType = e,
//	n.src = t,
//	xBrowser.onElementHitTest(n)
//}
function getTop(e) {
	var t = e.offsetTop;
	return null != e.offsetParent && (t += getTop(e.offsetParent)), t
}
function getLeft(e) {
	var t = e.offsetLeft;
	return null != e.offsetParent && (t += getLeft(e.offsetParent)), t
}

function setCookie(e, t) {
	if (t) {
		var n = 1,
		o = new Date;
		o.setTime(o.getTime() + 24 * n * 60 * 60 * 1e3),
		document.cookie = e + "=" + escape(t) + ";expires=" + o.toGMTString
	}
}
function getCookie(e) {
	var t,
	n = new RegExp("(^| )" + e + "=([^;]*)(;|$)");
	return (t = document.cookie.match(n)) ? unescape(t[2]) : null
}
function native_call_fetch_image_res() {
	for (var e = document.querySelectorAll("img"), t = 0; t < e.length; t++) {
		var n = e[t];
		if (n.width >= 200 && n.height >= 100 || n.height >= 200) {
			var o = n.parentNode;
			if (o && "a" == o.tagName.toLowerCase() && (o.href.indexOf(".png") > 0 || o.href.indexOf(".jpg") > 0)) {
				xBrowser.addImageRes("", o.href);
				continue
			}
			if (n.src.indexOf("data:image") >= 0)
				continue;
			xBrowser.addImageRes(n.alt, n.src)
		}
	}
}

function native_call_add_tag_to_resource() {
	for (var e = document.querySelectorAll("img"), t = 0; t < e.length; t++) {
		xBrowser.addTagToResource(e[t].src, "img");
	}

	for (var n = document.querySelectorAll("script"), t = 0; t < n.length; t++) {
		xBrowser.addTagToResource(n[t].src, "js");
	}

	for (var o = document.querySelectorAll("link"), t = 0; t < o.length; t++) {
		var r = o[t].href;
		if (r.indexOf("ico") > 0 || r.indexOf("png") > 0 || r.indexOf("jpg") > 0) {
		    xBrowser.addTagToResource(o[t].href, "img")
		} else {
		    xBrowser.log("resource-url:>>>>>>>" + o[t].href);
		    xBrowser.addTagToResource(o[t].href, "css");
		}
	}

	for (var l = document.querySelectorAll("video"), t = 0; t < l.length; t++) {
	    xBrowser.addTagToResource(l[t].src, "video");
	}

	for (var a = document.querySelectorAll("audio"), t = 0; t < a.length; t++) {
		xBrowser.addTagToResource(a[t].src, "audio")
	}
}

function native_call_sniff_media_res(e) {
	for (var t = document.querySelectorAll("video"), n = 0; n < t.length; n++) {
		var o = t[n];
		bind_video_events(o);
		xBrowser.addTagToResource(o.src, "video");
	}

	for (var r = document.querySelectorAll("iframe"), l = 0; l < r.length; l++) {
		var a = r[l];
		if (a.contentDocument) {
			var i = a.contentDocument.querySelector("video");
			if (i) {
			    bind_video_events(i);
			}
		}
	}

	for (var s = document.querySelectorAll("audio"), n = 0; n < s.length; n++) {
		xBrowser.addTagToResource(s[n].src, "audio");
	}

	for (var _ = document.querySelectorAll("link"), n = 0; n < _.length; n++) {
		var c = _[n].href;
		if (c.endsWith(".m3u8") > 0 || c.endsWith(".mp4") > 0) {
		    xBrowser.addTagToResource(_[n].href, "video");
		}
	}

	xBrowser.notifySniffMediaRes(e)
}

function nav_call_download_blob(e, t) {
	alert(e);
	const n = document.createElement("a");
	n.download = t, n.style.display = "none",
	n.href = e, document.body.appendChild(n),
	n.click(), document.body.removeChild(n)
}

function nav_call_decode_blob(e) {
	var t = new XMLHttpRequest;
	t.open("GET", e, true);
	t.setRequestHeader("Content-type", "");
	t.responseType = "blob";
	xBrowser.log(">>>>>>> nav_call_decode_blob:" + e);

	t.onreadystatechange = function () {
		alert("ok:" + t.statusText + " status:" + t.status + " state:" + t.readyState);
	};

	t.onload = function (e) {
		200 == this.status ? alert("ok") : alert("fail")
	};

	t.send();
}

function get_client_height() {
	var e = 0;
	if (document.body.clientHeight && document.documentElement.clientHeight)
		e = document.body.clientHeight < document.documentElement.clientHeight ? document.body.clientHeight : document.documentElement.clientHeight;
	else
		e = document.body.clientHeight > document.documentElement.clientHeight ? document.body.clientHeight : document.documentElement.clientHeight;
	return e
}

function is_touch_on_element(e, t, n) {
	if (e && e.offsetHeight) {
		var o = getLeft(e),
		r = o + e.clientWidth,
		l = getTop(e),
		a = l + e.clientHeight;
		return xBrowser.log("x:" + t + " y:" + n), t >= o && r >= t && n >= l && a >= n
	}

	return false
}

function showMessageOnNative(e, t) {
	try {
		xBrowser.showFloatMessageBox(e, t)
	} catch (n) {}
}

function cleanNativeMessage() {
	try {
		xBrowser.dismissFloatMessageBox()
	} catch (e) {}
}

function on_touch_video_element() {
	video_gesture_mode = true,
	xBrowser.setBrowserState(1)
}

function on_off_video_element() {
	video_gesture_mode = false,
	xBrowser.setBrowserState(0)
}

function tranx_has_set(e) {
	if (e.style) {
		var t = e.style.transform;
		if (t || (t = e.style.webkitTransform), t && (xBrowser.log("###can transform" + e.style.transform + " webkit-tran:" + e.style.webkitTransform), t.indexOf("(0px,") < 0))
			return xBrowser.log(">>>> element has trans........."), true
	}
	return false
}

function checkChildCanSwipe(e) {
	xBrowser.log(">>>###  do check target tran:" + e.tagName + " class:" + tagName["class"]);
	var t = false;
	if (tranx_has_set(e))
		return true;
	for (var n = 0; n < e.childElementCount; n++) {
		var o = e.children[n];
		if (t = checkChildCanSwipe(o))
			break
	}
	return t
}
function bind_li_data(e, t) {
	for (; e.parentNode && (xBrowser.log(">>>> touch tag name:" + e.tagName), "li" != e.tagName.toLowerCase()); )
		e = e.parentNode;
	e && "li" == e.tagName.toLowerCase() && (t.tagType = "li", t.li_id = e.getAttribute("id"), t.data_url = e.getAttribute("data-url"), t.data_title = e.getAttribute("data-title"), t.data_type = e.getAttribute("data-type"), t.data_status = e.getAttribute("data-status"), notify_got_hit_data(t))
}
function notify_got_hit_data(e) {
	xBrowser.onElementHitTest(e)
}
function do_hit(e, t, n) {
	var o = n.tagName.toLowerCase();
	if ("img" == o) {
	    var r = {};
		r.source = "normal";
		r.tagType = "img";
		r.src = n.src;
		notify_got_hit_data(r);
	} else if (document.location.host.indexOf("facebook") >= 0) {
		var l = false, a = document.querySelectorAll("i.img[data-store]");
		for (i in a) {
			var s = a[i];
			if (is_touch_on_element(e, t)) {
				JSON.parse(s.getAttribute("data-store"));
				r.source = "facebook",
				r.tagType = "img",
				r.src = n.src,
				notify_got_hit_data(r),
				touch_img = true
			}
		}

		if (!l) {
			a = document.querySelectorAll("i.img[style]"),
			xBrowser.log(" >>>> totlal image : " + a.length);
			for (i in a) {
				var s = a[i];
				if (is_touch_on_element(s, e, t) && s.style.backgroundImage) {
					var _ = s.style.backgroundImage;
					xBrowser.log("sniff src:" + s.style.backgroundImage);
					var c = /url\(\"(.*)\"\)/,
					d = _.match(c);
					if (d.length > 1) {
						xBrowser.log("found the image element .." + d[1]),
						r.source = "facebook",
						r.tagType = "img",
						r.src = n.src,
						notify_got_hit_data(r);
						break
					}
				}
			}
		}
	} else if (document.location.host.indexOf("instagram") >= 0) {
		var a = document.querySelectorAll("img");
		xBrowser.log(" totlal image : " + a.length);
		for (i in a) {
			var s = a[i];
			if (is_touch_on_element(s, e, t)) {
				r.source = "instagram",
				r.tagType = "img",
				r.src = n.src,
				notify_got_hit_data(notify_got_hit_data);
				break
			}
		}
	} else if (document.location.href.indexOf("file:///android_asset") >= 0) {
		try {
			bind_li_data(n, r);
		} catch (u) {
			xBrowser.log("catch bind_li_data error");
		}
	}

	("a" == o || n.parentElement && "a" == n.parentElement.tagName.toLowerCase()) && xBrowser.onTouchEventElement();
}
function check_swipe_element(e) {
	if (xBrowser.elementCanSwipe(false), "iframe" == e.tagName.toLowerCase())
		try {
			checkChildCanSwipe(e.contentDocument) && xBrowser.elementCanSwipe(true)
		} catch (t) {
			xBrowser.elementCanSwipe(true),
			xBrowser.log(t.message)
		}
	else {
		var n = e.className;
		for (n && n.indexOf("feed-slider") >= 0 && xBrowser.elementCanSwipe(true); e.parentNode; ) {
			if (tranx_has_set(e)) {
				xBrowser.elementCanSwipe(true);
				break
			}
			e = e.parentNode
		}
	}
	xBrowser.log("windows.scrollX:" + window.scrollX),
	window.scrollX > 0 && xBrowser.elementCanSwipe(true)
}
function clean_video_control_style() {
	var e = document.getElementById("video-style-control");
	e && e.parentElement && e.parentElement.removeChild(e)
}
function notify_video_play(e) {
	//CURRENT_VIDEO = e.target;
	xBrowser.notifyVideoPlayed(e);
}
function notify_video_load(e) {
	xBrowser.notifyVideoLoad(e)
}
function notify_time_update(e) {
	xBrowser.notifyVideoTimeUpdate(e)
}
function notify_video_paused(e) {
	xBrowser.notifyVideoPaused(e)
}
function notify_video_load_start(e) {
	console.log("========= video load start =============")
}
function notify_video_waiting(e) {
	console.log("========= video load waitting =============")

}
function notify_video_seeking() {
	xBrowser.log("========= video load seeking =============")
}
function bind_video_events(e) {
	e.addEventListener("play", notify_video_play);
	e.addEventListener("loadedmetadata", notify_video_load);
	e.addEventListener("timeupdate", notify_time_update);
	e.addEventListener("pause", notify_video_paused);
	e.addEventListener("waiting", notify_video_waiting);
	e.addEventListener("loadstart", notify_video_load_start);
	//CURRENT_VIDEO = e;
}
function bind_lib_hls(e, t) {
	var n = "x-lib-hls",
	o = document.getElementById(n);
	o || (o = document.createElement("script"), o.id = n, o.src = "/9217cf26ae1fb67224f4faa6e79a417f/lib.hls", o.onload = function () {
		try {
			var n = new Hls;
			n.loadSource(t),
			n.attachMedia(e)
		} catch (o) {}

	}, document.body.appendChild(o))
}

function find_video(e) {
    var src = xBrowser.getVideoPlaySrc(e)
    if (src && src != "") {
        return src;
    }

    return null;
}

function sniff_video_from_doc(doc) {
    try {
        var t = doc.querySelectorAll("video");
        xBrowser.log("sniff-video >>>> found :" + t.length + " videos");

        for (var n = 0; n < t.length; n++) {
            var o = t[n];
            var src = find_video(o);
            if (src) {
                bind_video_events(o);

                xBrowser.log("sniff-video >>>> video url :" + src);
                xBrowser.notifyHasVideoTag(src, o);
            }
        }
    } catch (e) {
        xBrowser.log(e);
    }
}

function sniff_video() {
    try {
        var docs = [];
        var top = 0;

        // push doc
        docs[top++] = document;

        while (top > 0) {
            // pop
            var doc = docs[--top];

            // sniff
            sniff_video_from_doc(doc);

            // iframe
            var iframes = doc.querySelectorAll("iframe");
            for (var i = 0; iframes && i < iframes.length; ++i) {
                if (iframes[i].contentDocument) {
                    docs[top++] = iframes[i].contentDocument;
                }
            }
        }
    } catch (e) {
        xBrowser.log(e);
    }

    try_sniff_times++;
}

//原来逻辑
//function sniff_video() {
//	var e = false;
//	try {
//		var t = document.querySelectorAll("video");
//		xBrowser.log("sniff-video >>>> found :" + t.length + " videos");
//
//		for (var n = 0; n < t.length; n++) {
//			var o = t[n];
//			bind_video_events(o);
//			e = true;
//		}
//
//		for (var r = document.querySelectorAll("iframe"), l = 0; l < r.length; l++) {
//			var a = r[l];
//			if (a.contentDocument) {
//				var i = a.contentDocument.querySelector("video");
//				if (i) {
//				    bind_video_events(i);
//				    e = true;
//				}
//			}
//		}
//	} catch (s) {
//		xBrowser.log(s)
//	}
//
//	if (e) {
//		var src = CURRENT_VIDEO.src;
//		if (!src || "" == src) {
//			var c = CURRENT_VIDEO.querySelector("source");
//			if (c) {
//			    src = c.src;
//			}
//		}
//
//		if (src) {
//		    xBrowser.log("sniff-video >>>> video url :" + src);
//		    xBrowser.notifyHasVideoTag(src);
//		}
//	}
//
//	try_sniff_times++;
//}

function sniff_video_later() {
	setTimeout(sniff_video, 1000);
}

//function show_video_url() {
//	CURRENT_VIDEO && (xBrowser.log("CURRENT_VIDEO URL:" + CURRENT_VIDEO.src), xBrowser.log("CURRENT_VIDEO CURRENT URL:" + CURRENT_VIDEO.currentSrc))
//}

function cancel_select() {
	var e = window.getSelection();
	if (e.removeAllRanges(), e = null, xBrowser.log(">>>>>>> exit select state >>>>>>>>>>>"), last_touch_a_element) {
		var t = last_touch_a_element.getAttribute("_href");
		last_touch_a_element.removeAttribute("_href"),
		t && last_touch_a_element.setAttribute("href", t)
	}
}
function get_a_element_by_touch(e) {
	if (1 == e.nodeType) {
		var t = e.querySelector("a");
		if (null != t)
			return t;
		var n = e.tagName.toLowerCase();
		if ("a" == n)
			return e;
		var o = e.parentNode;
		return o ? get_a_element_by_touch(o) : null
	}
	var r = e.parentNode;
	return r ? get_a_element_by_touch(r) : null
}
function get_text_elemt(e) {
	if (3 == e.nodeType)
		return e.parentNode;
	for (var t = e.childNodes, n = 0; n < t.length; n++) {
		var o = t[n];
		xBrowser.log(">>>>> travel child: " + o.nodeName);
		var r = get_text_elemt(o);
		if (null != r)
			return r
	}
	return null
}
function select_text2(x, y, width, height) {
	var r = x * (window.innerWidth / width);
	var l = y * (window.innerHeight / height);
	var a = document.elementFromPoint(r, l);
	var i = window.getSelection();
	i.removeAllRanges();
	i.selectAllChildren(a);
}
function select_text(x, y, width, height) {
	var r = x * (window.innerWidth / width);
	var l = y * (window.innerHeight / height);
	var a = (r * (width / window.innerWidth), l * (height / window.innerHeight), document.elementFromPoint(r, l)), i = a.tagName.toLowerCase();
	if (xBrowser.log("########### try rewrite href element:#########" + a.tagName + " class:" + a.className), last_touch_a_element = get_a_element_by_touch(a)) {
		var s = last_touch_a_element.getAttribute("href");
		if (s && (last_touch_a_element.removeAttribute("href"), last_touch_a_element.setAttribute("_href", s)), "img" == i) {
			var _ = get_text_elemt(last_touch_a_element), c = window.getSelection();
			return c.removeAllRanges(), void c.selectAllChildren(_)
		}
	} else {
		xBrowser.log(">>>>>>>>>>>>>>> not found a elements ");
	}

	xBrowser.sendLongPress(x, y)
}
function get_main_domain(e) {
	var t = e,
	n = e.indexOf("://");
	n > 0 && (t = e.substring(n + 3));
	var o = t.indexOf("."),
	r = t.lastIndexOf("."),
	l = t.indexOf("/");
	return r == o ? t : l > 0 ? t.substring(o + 1, l) : t.substring(o + 1)
}
function native_touch_to_element(x, y, w, h) {
	x *= window.innerWidth / w,
	y *= window.innerHeight / h,
	last_point.left = x,
	last_point.top = y;
	return document.elementFromPoint(x, y);
}
function hit_swipe_element(x, y, w, h) {
	check_swipe_element(native_touch_to_element(x, y, w, h))
}
function hit_test(x, y, w, h) {
	var r = native_touch_to_element(x, y, w, h);
	if (r) {
		xBrowser.log("hit-test:x:" + x + " y:" + y + " target:" + r.tagName);
		do_hit(x, y, r);

		var l = find_fit_element(r);
		xBrowser.log("find_fit_element:" + l);

		if (is_mark_able_element(l)) {
		    CURRENT_ELEMENT = l;
		    xBrowser.setHitElementMarkable();
		} else {
		    CURRENT_ELEMENT = r;
		}

		LAST_HIT_ELEMENT = CURRENT_ELEMENT;
	} else {
		xBrowser.log(">>>>>>>>>>>>>> No corresponding element found. (" + x + "," + y + ") >>>>>>>>>>>>>>>")
	}
}
function clean_selected_state() {
	var e = document.querySelector("#x_select_state_mask");
	if (e) {
	    e.parentElement.removeChild(e);
	}
}
function show_select_state(e) {
	if (e) {
		var t = document.createElement("div");
		t.id = "x_select_state_mask",
		t.style.width = e.offsetWidth + "px",
		t.style.height = e.offsetHeight + "px",
		t.style.background = "RED",
		t.style.opacity = "0.3",
		t.style.position = "absolute",
		t.style.display = "block",
		t.style.top = "0px",
		t.style.left = "0px",
		t.style.zIndex = 2147483647,
		e.appendChild(t)
	}
}

function set_selected_state(e, t) {
    //t ? (e.old_style = e.getAttribute("style"), e.style = e.old_style + ";opacity:0.3;background-color:red;padding:2px") : e.old_style ? e.setAttribute("style", e.old_style) : e.setAttribute("style", "")
    if (e) {
        if (t) {
            e.old_style = e.getAttribute("style");
            e.style = e.old_style + ";opacity:0.3;background-color:red;padding:2px";
        } else if (e.old_style) {
            e.setAttribute("style", e.old_style);
        } else {
            e.setAttribute("style", "");
        }
    }
}

function do_execute_rule(e) {
	xBrowser.log("==================  start execute rule :" + e + "=====================");

	var t = e, n = e.indexOf("->"), o = 0, r = 0, l = 0, a = 0, i = 0, s = 0, _ = false;
	if (n > 0) {
	    t = e.substring(0, n);

		var c = e.substring(n + 2);
		if (c && c.indexOf("m") >= 0 && (_ = true), c.indexOf(":") > 0) {
			var d = c.split(":");
			if (c.indexOf("m") < 0) {
				r = parseInt(d[0]);
				l = parseInt(d[1]);
				a = parseInt(d[2]);
				i = parseInt(d[3]);
			} else {
				var u = parseInt(0);
				r = parseInt(d[1]);
				l = parseInt(d[2]);
				a = parseInt(d[3]);
				i = parseInt(d[4]);
				"m" == u && (_ = true);
				s = 2;
			}

			// 开始：2020年3月3日修改 标识的规则不使用范围了匹配了，提高匹配成功率，但可能存在误杀
            //if (t.indexOf(':') >= 0 || t.indexOf('|') >= 0
            //        || t.indexOf('+') >= 0 || t.indexOf('~') >= 0
            //        || t.indexOf('>') >= 0 || t.indexOf('.') >= 0
            //         || t.indexOf('#') >= 0 || t.indexOf('[') >= 0
            //         || t.indexOf(' ') >= 0 || t.indexOf(',') >= 0) {
            //    s = 0;
            //    r = 0;
            //    l = 0;
            //    a = 0;
            //    i = 0;
            //    _ = false;
			//}
			// 结束：2020年3月3日修改 标识的规则不使用范围了匹配了，提高匹配成功率，但可能存在误杀
		} else {
			o = parseInt(c);
			s = 1;
		}
	}

	var m = t;
	var f;

	try {
	   f = document.querySelectorAll(t);
	} catch (e) {
	   //console.error(e)
	   return
	}

	if (f.length > 0) {
		if (l > 0 || r > 0) {
			s = 2;
		} else {
			if (o > 0 && f.length < o) {
				return;
			}

			s = o > 0 ? 1 : 0
		}
	}

	if (_ && 0 == f.length) {
		var g = "", d = t.indexOf("#"), E = t.indexOf("."), h = t.indexOf("[");
		if ((d > 0 && 0 > h || d > 0 && h > d)  && (g = t.substring(0, d)), 0 > d
		    && E > 0 && (0 > h || h > E) && (g = t.substring(0, E)), 0 > d
		    && 0 > E && h > 0 && (g = t.substring(0, h)), E > 0 && h > E
		    && (t = t.substring(E), t = g + t, t != m && (xBrowser.log(">>>>>>>>> try selector 1:" + t + ">>>>>>>>>>>>"), f = document.querySelectorAll(t))), 0 == f.length
		    && h > 0) {
			var v = m.substring(h);
			t = g + v,
			t != m && (xBrowser.log(">>>>>>>>> try selector 2:" + t + ">>>>>>>>>>>>"), f = document.querySelectorAll(t)),
			0 == f.length && v && (t = v, xBrowser.log(">>>>>>>>> try selector 3:" + t + ">>>>>>>>>>>>"), f = document.querySelectorAll(v))
		}

		if (0 == f.length && g && 2 == s
		    && (t = g, xBrowser.log(">>>>>>>>> try selector 4:" + t + ">>>>>>>>>>>>"), f = document.querySelectorAll(t)), 0 == s
		    && f.length >= 3 || f.length > 50) {
		    return
		}
	}

	xBrowser.log(">>>>>>>>>>debug-rule:" + t + " left:" + r + " top:" + l + " type " + s + " element len " + f.length + " is mark rule:" + _);
	for (var p = 0; p < f.length; p++) {
		var y = f[p];
		if (y && 1 == y.nodeType) {
			var T = y.parentElement;
			if (T) {
				if (1 == s && "a" == T.tagName.toLowerCase()) {
					var b = T.href;
					var w = get_main_domain(window.location.host);
					if (b.indexOf("http") >= 0 && b.indexOf(w) < 0) {
					    T.removeChild(y);
					}
				} else if (2 == s) {
					var N = getLeft(y);
					var C = getTop(y);
					var S = y.offsetWidth;
					var L = y.offsetHeight;
					xBrowser.log(">>>> TAG:" + y.tagName + " _top:" + C + " _left:" + N + " _w:" + S + " _h:" + L);

					if (Math.abs(N - r) < 30 && Math.abs(C - l) < 30 && S == a && L == i) {
						xBrowser.log("found hit ad by selector " + t + " tagName:" + y.tagName);
						T.removeChild(y);
						break;
					}
				} else {
					T.removeChild(y);
					xBrowser.log("found hit ad by selector " + t + " tagName:" + y.tagName);
				}
			}
		}
	}

	if (f.length > 0) {
	    add_hit_rule(e);
	}
}

function execute_element_rules() {
    var rules = xBrowser.getElementRules(document.location.host);

    xBrowser.time("execute-element-rule-cost-time");
    for (var t = 0; t < rules.length; t++) {
        var n = rules[t];
        xBrowser.log("=========== execute rule:" + n + "================");

        if (!is_hit_rule(n)) {
            do_execute_rule(n);
        }
    }
    xBrowser.timeEnd("execute-element-rule-cost-time");
}

function execute_mark_rules() {
    var rules = xBrowser.getElementRules(document.location.host);

	xBrowser.time("execute-user-mark-rule-cost-time");
	for (var e = 0; e < rules.length; e++) {
		var t = rules[e];
		if (t.indexOf("->m") > 0 && !is_hit_rule(t)) {
		    do_execute_rule(t);
		}
	}
	xBrowser.timeEnd("execute-user-mark-rule-cost-time");
}

function is_hit_rule(e) {
	for (var t = 0; t < g_hit_rules.length; t++) {
		if (g_hit_rules[t] == e) {
		    return true;
		}
	}
	return false;
}

function add_hit_rule(e) {
	g_hit_rules.push(e);
	xBrowser.logBlockOneAd(window.location.href, window.location.host, e, 3);
}

function cancel_marked_element() {
	SELECTED_ELEMENT && (set_selected_state(SELECTED_ELEMENT, false), SELECTED_ELEMENT = null)
}

function adjustment_area() {
	if (CURRENT_ELEMENT) {
	    if (CURRENT_ELEMENT.childElementCount > 0) {
	        xBrowser.log(">>>>>>>> fist child :" + CURRENT_ELEMENT.firstElementChild.tagName);
	        CURRENT_ELEMENT = CURRENT_ELEMENT.firstElementChild;
	        update_element_state();
	    } else if (CURRENT_ELEMENT.nextElementSibling) {
	        CURRENT_ELEMENT = CURRENT_ELEMENT.nextElementSibling;
	        update_element_state();
	    } else {
	        CURRENT_ELEMENT = LAST_HIT_ELEMENT;
	        update_element_state();
	    }
	} else if (LAST_HIT_ELEMENT) {
		CURRENT_ELEMENT = LAST_HIT_ELEMENT;
    	update_element_state();
	} else {
        xBrowser.log(">>>>> SELECTED ELEMENT IS NULL >>>>>");
	}
}

function test_rule() {
	var e = document.querySelectorAll("div[style='overflow: hidden; background: rgb(255, 255, 255);']");
	xBrowser.log(" >>>>> test elements " + e.length);
}

function gen_element_rule(e, fuzzy) {
    var t = "", n = e.id, o = "", r = window.location.host, l = e.tagName, a = e.getAttributeNames(), i = "", s = "", _ = "";

	for (var c = 0; c < e.classList.length; c++) {
		o += "." + e.classList.item(c);
	}

	for (var d = 0; d < a.length; d++) {
		var u = false, m = true, f = a[d], g = e.getAttribute(f);
		if ("class" != f && "id" != f && "title" != f && ("style" != f || g)) {
			if (g || (m = false), f.indexOf("src") >= 0 || f.indexOf("href") >= 0 || f.indexOf("source") >= 0) {
				var idx = g.indexOf("?");
				if (idx > 0) {
				    g = g.substring(0, idx);
				    u = true;
				}
			}

			_ += m ? u ? "[" + f + "^='" + g + "']" : "[" + f + "='" + g + "']" : "[" + f + "]";
		}
	}

	l && (i += l),
	n && (i += "#" + n),
	o && (i += o),
	_ && (i += _);

	var h = document.querySelectorAll(i);
	return h.length > 2,
	s = "->m:" + getLeft(e) + ":" + getTop(e) + ":" + e.offsetWidth + ":" + e.offsetHeight,
	t = r ? r + "##" + i : "##" + i, (fuzzy ? t : t += s)
}

function commit_marked_element(fuzzy) {
	if (SELECTED_ELEMENT) {
		var e = SELECTED_ELEMENT;
		set_selected_state(e, false);

		var t = gen_element_rule(e, fuzzy);
		xBrowser.log(">>>> gen rule:" + t + " parent:" + e.parentElement.tagName + " fuzzy:" + fuzzy);
		xBrowser.addAdBlockRule(t, window.location.host, document.location.href, 3);

		if (e.parentElement) {
		    e.parentElement.removeChild(e);
		} else {
		    document.removeChild(e);
		}

		SELECTED_ELEMENT = null;
	}
}

function update_element_state() {
    if (xBrowser.isInMarkAdMode()) {
        if (SELECTED_ELEMENT) {
            if (SELECTED_ELEMENT == CURRENT_ELEMENT) {
                set_selected_state(SELECTED_ELEMENT, false);
                SELECTED_ELEMENT = null;
            } else {
                set_selected_state(SELECTED_ELEMENT, false);
                SELECTED_ELEMENT = CURRENT_ELEMENT;
                set_selected_state(SELECTED_ELEMENT, true);
            }
        } else {
            SELECTED_ELEMENT = CURRENT_ELEMENT;
            set_selected_state(SELECTED_ELEMENT, true);
        }

        if (SELECTED_ELEMENT) {
            var t = gen_element_rule(SELECTED_ELEMENT, false);
            xBrowser.log(">>>> gen rule:" + t + " parent:" + SELECTED_ELEMENT.parentElement.tagName);
            xBrowser.previewAdBlockRule(t, window.location.host, document.location.href, 3);
        }
    }
}

function is_mark_able_element(e) {
	var t = (e.innerText && e.innerText.trim().length, e.querySelector("input"));
	return e.offsetHeight < g_max_ad_container_height && "p" != e.tagName.toLowerCase() && null == t;
}

function find_fit_element(e) {
	for (; e.parentElement != null && e.parentElement.offsetHeight < g_max_ad_container_height; ) {
		e.parentElement, e = e.parentElement;
	}

	if (0 == e.offsetHeight && e.children.length > 0) {
		for (var t = 0; t < e.children.length; t++) {
			var n = e.children[t];
			if (n.offsetHeight < g_max_ad_container_height && n.offsetHeight >= g_min_ad_container_height) {
				e = n;
				break
			}
		}
	}

	return e
}
function high_light_auto_fill(e) {
	e && (e.style.background = "#F9FBBF", e.style.backgroundClip = "content-box")
}
function set_input_text(e, t) {
	e.value = t;
	var n = document.createEvent("Events");
	n.initEvent("input", true, true),
	e.dispatchEvent(n)
}
function auto_fill_by_form_data(e) {
	var t = e.id,
	n = e.name,
	o = e.placeholder;
	if ("password" == e.type) {
		var r = g_fill_form_data.password;
		if (r)
			return set_input_text(e, r), void high_light_auto_fill(e)
	}
	if (n) {
		var l = g_fill_form_data[n];
		if (l)
			return set_input_text(e, l), void high_light_auto_fill(e)
	}
	if (t) {
		var a = g_fill_form_data[t];
		if (xBrowser.log(">>>>> fetch by id : " + a), a)
			return set_input_text(e, a), void high_light_auto_fill(e)
	}
	if (o) {
		var i = g_fill_form_data[o];
		if (xBrowser.log(">>>>> fetch by ph : " + i), i)
			return set_input_text(e, i), void high_light_auto_fill(e)
	}
}
function sync_auto_fill_data() {
	var e = JSON.stringify(g_fill_form_data);
	xBrowser.log(">>>>>> call sync_auto_fill_data function >>>>>>>>" + e),
	xBrowser.syncAutoFillFormData(document.location.host, e)
}
function sync_data_later() {
	g_timer && clearTimeout(g_timer),
	g_timer = setTimeout(sync_auto_fill_data, 1e3)
}
function can_auto_fill(e) {
	if (e) {
		if ("hidden" == e.type)
			return false;
		if ("password" == e.type)
			return e._bind_event_password || (e.addEventListener("input", function () {
					g_fill_form_data.password = e.value,
					sync_data_later()
				}), e._bind_event_password = true), true;
		for (var t = 0; t < g_auto_fill_keywords.length; t++) {
			var n = g_auto_fill_keywords[t],
			o = e.name,
			r = e.id,
			l = e.placeholder;
			if (o && o.toLowerCase().indexOf(n) >= 0)
				return e["_bind_event_" + o] || (xBrowser.log("==== bind envent ==========="), e.addEventListener("input", function () {
						g_fill_form_data[o] = e.value,
						sync_data_later()
					}), e["_bind_event_" + o] = true), true;
			if (r && r.toLowerCase().indexOf(n) >= 0)
				return e["_bind_event_" + r] || (e.addEventListener("input", function () {
						g_fill_form_data[r] = e.value,
						sync_data_later()
					}), e["_bind_event_" + r] = true), true;
			if (l && l.toLowerCase().indexOf(n) >= 0)
				return e._bind_event_placeholder || (e.addEventListener("input", function () {
						g_fill_form_data[l] = e.value,
						sync_data_later()
					}), e._bind_event_placeholder = true), true
		}
	}
	return false
}
function auto_fill_form() {
	var e = document.querySelectorAll("input");
	xBrowser.log("======== total input element:total " + e.length);
	for (var t = 0; t < e.length; t++) {
		var n = e[t];
		can_auto_fill(n) && (xBrowser.log("======== found can auto fill input ==========" + n.name), auto_fill_by_form_data(n))
	}
}
function _b(e, t) {
	for (var n = 0; n < t.length - 2; n += 3) {
		var o = t.charAt(n + 2),
		o = o >= "a" ? o.charCodeAt(0) - 87 : Number(o),
		o = "+" == t.charAt(n + 1) ? e >>> o : e << o;
		e = "+" == t.charAt(n) ? e + o & 4294967295 : e^o
	}
	return e
}
function tk(e) {
	for (var t = TKK.split("."), n = Number(t[0]) || 0, o = [], r = 0, l = 0; l < e.length; l++) {
		var a = e.charCodeAt(l);
		128 > a ? o[r++] = a : (2048 > a ? o[r++] = a >> 6 | 192 : (55296 == (64512 & a) && l + 1 < e.length && 56320 == (64512 & e.charCodeAt(l + 1)) ? (a = 65536 + ((1023 & a) << 10) + (1023 & e.charCodeAt(++l)), o[r++] = a >> 18 | 240, o[r++] = a >> 12 & 63 | 128) : o[r++] = a >> 12 | 224, o[r++] = a >> 6 & 63 | 128), o[r++] = 63 & a | 128)
	}
	for (e = n, r = 0; r < o.length; r++)
		e += o[r], e = _b(e, "+-a^+6");
	return e = _b(e, "+-3^+b+-f"),
	e ^= Number(t[1]) || 0,
	0 > e && (e = (2147483647 & e) + 2147483648),
	e %= 1e6,
	e.toString() + "." + (e^n)
}
function needInjectCss() {
	return xBrowser.needInjectCss() && document.location.href.indexOf("article_list_for_xb_readmode") < 0
}
function applyToDesktopMode(e) {
	var t = document.querySelector('meta[name="viewport"]');
	t && (e ? t.content = "width=1280" : t.content = "width=device-width initial-scale=1.0")
}
function _main_() {
	alert("not found _main_() function")
}
function _x_inject_script(e) {
	var t = document.getElementsByTagName("head").item(0), n = document.createElement("script");
	return n.type = "text/javascript", n.src = e, t.appendChild(n), n
}

/*function googleTranslateElementInit() {
	getCookie("googtrans") || setCookie("googtrans", "/auto/" + xBrowser.getTranLang()),
	new google.translate.TranslateElement({
		pageLanguage : "auto"
	}, "google_translate_element"),
	xBrowser.showToast(xBrowser.getStringResource("toast_perform_page_tran"))
}
function inject_google_trans_widget() {
	var e = document.getElementsByTagName("body").item(0),
	t = document.querySelector("#google_translate_element");
	if (t) {
		googleTranslateElementInit();
	} else {
		var n = document.createElement("div");
		n.id = "google_translate_element",
		e.appendChild(n);
		var o = document.createElement("script");
		o.type = "text/javascript",
		o.src = xBrowser.getGoogleTranUrl(),
		e.appendChild(o)
	}
}*/

function inject_script_with_callback_id(e, t) {
	for (var n = t.split(","), o = 0; o < n.length; o++) {
		var r = _x_inject_script(n[o]);
		o == n.length - 1 && (r.onload = function () {
			xBrowser.onScriptReady(e)
		})
	}
}

function stop_timer() {
	for (var e = setInterval(null, 1e4), t = 0; e >= t; t++)
		clearInterval(t)
}

function execute_rules() {
	execute_element_rules();
	execute_mark_rules();
	execute_hidden_rules(document, false);
	setTimeout(function() {execute_hidden_rules(document, true)}, 1000)
}

function execute_rules_later() {
	setTimeout(execute_rules, 300);
}

function execute_auto_fill() {
	if ("" != window.location.host) {
		var e = xBrowser.loadAutoFillFormData(window.location.host);
		g_fill_form_data = JSON.parse(e);
		g_fill_form_data.constructor == Array && (g_fill_form_data = {});
		xBrowser.log(" >>>>>> start auto_fill_form >>>>>>>>:" + e);
		auto_fill_form();
	}
}

function execute_auto_fill_later() {
	setTimeout(execute_auto_fill, 600)
}

function execute_hidden_rules(e, alpha) {
    if (xBrowser.adBlockLevel == 0) {
        xBrowser.log("-----------hidden block element ad block level 0");
        return
    }

    if (xBrowser.isInWhiteHosts(window.location.host)) {
        xBrowser.log("-----------hidden block element in white hosts:" + window.location.host);
        return
    }

    for (var i = 0; i < e.childElementCount; ++i) {
        var s = e.children[i];
        //var style = s.getAttribute('style');
        if (s.id == null || !(s.id.indexOf('vconsole') >= 0 || s.id.indexOf('wanda') >= 0)) {
            if (s.style != null && s.style['pointer-events'] == 'none'
                    && s.childElementCount > 0 && s.getElementsByTagName('style').length > 0) { // position: relative; width: 412px; height: 128.75px; pointer-events: none;
                xBrowser.log("-----------hidden block element3:" + s.tagName);
                if (alpha) {
                    s.style.opacity = 0;
                    s.style['pointer-events'] = "none";
                } else {
                    s.style.display = 'none';
                }
            }

            if (s.style != null && s.style.display != null && s.style.display == 'block') {
                xBrowser.log("-----------hidden block element1:" + s.tagName);
                if (alpha) {
                    s.style.opacity = 0;
                    s.style['pointer-events'] = "none";
                } else {
                    s.style.display = 'none';
                }
            }

            if (s.style != null && s.style['z-index'] != null && s.style['z-index'] == 2147483647) {//z-index:2147483647
                xBrowser.log("-----------hidden block element2:" + s.tagName);
                if (alpha) {
                    s.style.opacity = 0;
                    s.style['pointer-events'] = "none";
                } else {
                    s.style.display = 'none';
                }
            }

            if (s.childElementCount > 0) {
                execute_hidden_rules(s, alpha);
            }
        }
    }
}

function main() {
    xBrowser.log("============  start main entry ===================");

    sniff_video_later();
    //needInjectCss() && (applyOuterCSS(), xBrowser.onOuterCSSApplied());
    xBrowser.adBlockActived() && execute_rules_later();
    //xBrowser.autoSavePasswd() && execute_auto_fill_later();
    //appExtraCss();
    document.addEventListener("DOMContentLoaded", function(){
        xBrowser.log("============ dom load finished =============");
        g_dom_load_finished = true;

        for (var e = document.querySelectorAll("iframe"), t = 0; t < e.length; t++) {
            e[t].setAttribute("allowfullscreen", true);
        }

        //xBrowser.onDOMContentLoaded();
        //needInjectCss() && (applyOuterCSS(), xBrowser.onOuterCSSApplied());
        sniff_video_later();

        if (xBrowser.adBlockActived()) {
            execute_rules();

            var n = 200;
            for (var t = 0; 5 >= t; t++) {
                setTimeout(function() {execute_rules()}, n);
                n += 100 * t;
            }
        }
    }, false);

    window.addEventListener("touchend", function(e) {
        var e = e || window.event;
        xBrowser.log("touchend e:" + e);

        if (xBrowser.isInMarkAdMode()) {
            adjustment_area();
            return e && e.preventDefault();
        }

        return false;
    }, false);

    window.addEventListener("load", function () {
        xBrowser.log("============ page load finished =============");
        //xBrowser.onPageLoaded();
        g_page_load_finished = true;
        xBrowser.log("============  page load on night ===================");
        //xBrowser.inNightMode() && applyOuterCSS();
        sniff_video_later();
        //xBrowser.autoSavePasswd() && execute_auto_fill();
        xBrowser.adBlockActived() && execute_rules();
    }, false);

    document.onselectionchange = function () {
        var e = window.getSelection().toString();
        if (e && e.length > 0) {
            in_selection = true;
            var t = tk(e);
            xBrowser.onSelectTextChange(e, t)
        } else {
            xBrowser.log("in_selection:" + in_selection), 1 == in_selection && (in_selection = false, xBrowser.onSelectTextChange(e, ""))
        }
    };
}

// app 调用
function doIdleHandle() {
    xBrowser.log("doIdleHandle");
    sniff_video_later();
    execute_rules();
}

function doHitTest(x, y, w, h) {
    hit_test(x, y, w, h)
}

function doSelectText(x, y, w, h) {
    select_text(x, y, w, h)
}

function doAdMark() {
    xBrowser.adMarkMode = true;
    adjustment_area();
}

function doAdMarkConfirm(fuzzy) {
    xBrowser.adMarkMode = false;
    commit_marked_element(fuzzy);
}

function doAdMarkAdjust() {
    adjustment_area();
}

function doAdMarkCancel() {
    cancel_marked_element();
    xBrowser.adMarkMode = false;
}

function doVideoPlay(id) {
    var videoEle = xBrowser.getVideoById(id);
    xBrowser.log("doVideoPlay:" + id + ", videoEle:" + videoEle);

    if (videoEle && videoEle.paused) {
        videoEle.play();
    }
}

function doVideoPause(id) {
    var videoEle = xBrowser.getVideoById(id);
    xBrowser.log("doVideoPause:" + id + ", videoEle:" + videoEle);

    if (videoEle && !videoEle.paused) {
        videoEle.pause();
    }
}

function doVideoSeek(id, pos) {
    var videoEle = xBrowser.getVideoById(id);
    xBrowser.log("doVideoSeek:" + id + ", videoEle:" + videoEle + ", pos:" + pos);

    if (videoEle) {
        videoEle.currentTime = pos;
    }
}

function doVideoFullScreen(id) {
    var videoEle = xBrowser.getVideoById(id);
    xBrowser.log("doVideoFullScreen:" + id + ", videoEle:" + videoEle);

    if (videoEle) {
        videoEle.webkitRequestFullScreen();
    }
}

function doVideoPlaybackRate(id, rate) {
    var videoEle = xBrowser.getVideoById(id);
    xBrowser.log("doVideoPlaybackRate:" + id + ", videoEle:" + videoEle + ", rate:" + rate);

    if (videoEle) {
        videoEle.playbackRate = rate;
    }
}

!function() {
    xBrowser.log("============  start js ===================");

    // hack greasyfork install script tips
    if (window.location != null
        && window.location.host != null
        && window.location.host.indexOf('greasyfork') >= 0) {
        localStorage.setItem('manualOverrideInstallJS', '1');
    }

    window.onInitSite = function(params) {
        var p = JSON.parse(params);
        g_element_rules = p.elementRules;
        xBrowser.adBlock = p.adBlock;
        xBrowser.adBlockLevel = p.adBlockLevel;

        if (p.whiteHosts != null && p.whiteHosts.length > 0) {
            xBrowser.whiteHosts = p.whiteHosts;
        }

        xBrowser.timeEnd("load-element-rule-cost-time")
        xBrowser.log("======  total [" + g_element_rules.length + "] element rule  ======");
        main();
    };

    xBrowser.time("load-element-rule-cost-time");
	XLBrowser.sendMessage('initSite', '{"host":"' + window.location.host + '"}', 'window.onInitSite');
}();
